//////////////////////////////////////////////////
//////////////////////////////////////////////////
// This source code is Copyright (2011) of      //
//  Jeppe R. Andersen and Jennifer M. Smillie   //
// and is distributed under the                 //
// Gnu Public License version 2                 //
// http://www.gnu.org/licenses/gpl-2.0.html     //
// You are allowed to distribute and alter the  //
// source under the conditions of the GPLv2     //
// as long as this copyright notice             //
// is unaltered and distributed with the source //
// Any use should comply with the               //
//             MCNET GUIDELINES                 //
//    for Event Generator Authors and Users     //
// as distributed with this source code         //
//////////////////////////////////////////////////
//////////////////////////////////////////////////
#ifndef _MOMENTUMDEFJET_H_INCLUDED_
#define _MOMENTUMDEFJET_H_INCLUDED_
#include "Jets.h"
#define new 1
extern int MDtemp[48][6];
extern int MDtemp3[12][5];
extern int MDtemp2[4][4];
typedef void (*tpMGfunc)(FREAL * , FREAL *);
#if new
/* typedef std::vector<int> tpmomshuffle; */
typedef int tpmomshuffle;
struct sPMchoice // Structure for Process and Momentum choice
{
  tpMGfunc MGfunc;
  bool ptype; // p(0) or q(1)?
  /* std::vector<tpmomshuffle> MomShuffleVector; */
  std::vector<int> MomShuffleVector;
  int idpartmult;
};
#else
typedef void (*tpmompick)(double [][4], double [][4], particle*, particle *);
struct sPMchoice // Structure for Process and Momentum choice
{
  tpMGfunc MGfunc;
  std::vector<tpmompick> MomPickVector;
  int idpartmult;
};
#endif
double PickAndEvalProcAndMom2J(std::vector<sPMchoice> NonFKLProcesses, double p[4][4]);
double PickProcAndEval2J(std::vector<sPMchoice> NonFKLProcesses, double p[4][4]);
double PickMomAndEval2J(std::vector<sPMchoice> NonFKLProcesses, double p[4][4]);
double NoPickButEval2J(std::vector<sPMchoice> NonFKLProcesses, double p[4][4]);
double PickAndEvalProcAndMom3J(std::vector<sPMchoice> NonFKLProcesses, double p[5][4]);
double PickMomAndEval3J(std::vector<sPMchoice> NonFKLProcesses, double p[5][4]);
double PickAndEvalProcAndMom4J(std::vector<sPMchoice> NonFKLProcesses, double p[6][4]);
#endif
